import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "%WOVQPOOOnQPO'#C_OOQO'#C_'#C_Q!VQPOOOOQO'#Cb'#CbO!bQPO'#CfOOQO'#Ci'#CiOVQPO'#ClOOQO'#Co'#CoO!yQPO'#CnOOQO'#Cf'#CfOOQO'#C^'#C^O#OQPO,58{OVQPO,58}OVQPO,59OOVQPO,59PO#TQPO,59TO#YQPO'#CmO#kQPO,59WOVQPO,59YOOQO1G.g1G.gOOQO1G.i1G.iO#pQPO1G.jO$UQPO1G.kOOQO1G.o1G.oOVQPO'#CqO$jQPO,59XOOQO1G.r1G.rO$rQPO1G.tO$wQPO,59]OOQO-E6o-E6oOOQO7+$`7+$`",
  stateData: "%]~OhOS~OSPOZYO[TO^UO_YOdWOnVO~Oi[OfRXjRXkRXlRXoRXpRX~Oj]Ok^Ol_O~Om`OfYXjYXkYXlYXoYXpYX~OncO~OSdO~O[hO~Oj]Ok^Ol_OoiOpaX~OpkO~Oj]OfWikWilWioWipWi~Oj]Ok^OfXilXioXipXi~OoiOpaa~OpoO~Oj]Ok^Ol_Ooeapea~OSd~",
  goto: "#VfPPgzP!Tz!^!^!^zPP!gPP!g!p!g!vP#PQROSaVcQe]Qf^Qg_Rmi_ZOV]^_ci_QOV]^_ci_SOV]^_ci_YOV]^_ciQbVRlc_XOV]^_ciQjaRnj",
  nodeNames: "⚠ Program Expression CellReference AlphaNumCellReference CellReferenceRange BinaryExpression Boolean Product Addition Scalar Number String MeasureReference MachineMeasureReference TableReference Parentheses Arguments FunctionCall FunctionIdentifier Identifier",
  maxTerm: 32,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "-u~RmX^!|pq!|qr#qrs#|tu%Qxy%xyz%}z{&S{|&X|}&^}!O&X!O!P&c!P!Q&S!Q![&h![!]'R!^!_'W!_!`#q!`!a'W!c!}'`#T#o'`#o#p'q#y#z!|$f$g!|#BY#BZ!|$IS$I_!|$I|$JO!|$JT$JU!|$KV$KW!|&FU&FV!|~#RYh~X^!|pq!|#y#z!|$f$g!|#BY#BZ!|$IS$I_!|$I|$JO!|$JT$JU!|$KV$KW!|&FU&FV!|~#tP!_!`#w~#|Oj~~$PTOr$`s#Q$`#R;'S$`;'S;=`$z<%lO$`~$cUOr$`rs$us#Q$`#R;'S$`;'S;=`$z<%lO$`~$zO[~~$}P;=`<%l$`~%TQ!c!}%Z#T#o%Z~%^Stu%j!Q![%p!c!}%Z#T#o%Z~%mP!Q![%p~%uPS~!Q![%p~%}On~~&SOp~~&XOk~~&^Ol~~&cOo~~&hOm~~&mQZ~!O!P&s!Q![&h~&vP!Q![&y~'OPZ~!Q![&y~'WOi~~']Pj~!_!`#w~'eSd~tu%j!Q![%p!c!}'`#T#o'`~'tP#o#p'w~'zQ!o!p(Q!v!w+o~(TP#X#Y(W~(ZP#T#U(^~(aP#g#h(d~(gP#i#j(j~(mP#f#g(p~(sP#X#Y(v~(yP#p#q(|~)PPrs)S~)VTOr)fs#Q)f#R;'S)f;'S;=`+i<%lO)f~)iUOr)frs){s#Q)f#R;'S)f;'S;=`+i<%lO)f~*OP!O!P*R~*UPrs*X~*[TOr*ks#Q*k#R;'S*k;'S;=`+c<%lO*k~*nUOr*krs+Qs#Q*k#R;'S*k;'S;=`+c<%lO*k~+TP#q#r+W~+ZP#q#r+^~+cO^~~+fP;=`<%l*k~+lP;=`<%l)f~+rP#T#U+u~+xP#U#V+{~,OP#`#a,R~,UP#X#Y,X~,[P#p#q,_~,bPrs,e~,hTOr,ws#Q,w#R;'S,w;'S;=`-o<%lO,w~,zUOr,wrs-^s#Q,w#R;'S,w;'S;=`-o<%lO,w~-aP#q#r-d~-gP#q#r-j~-oO_~~-rP;=`<%l,w",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 194
});

const nobieSheetsLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                AlphaNumCellReference: tags.name,
                Number: tags.number,
                String: tags.string,
                Identifier: tags.variableName,
                Boolean: tags.bool,
                LineComment: tags.lineComment,
                "( )": tags.paren,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nobieSheets() {
    return new LanguageSupport(nobieSheetsLanguage);
}

export { nobieSheets, nobieSheetsLanguage };
